Index: trunk/source/geometry/magneticfield/src/G4DELPHIMagField.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4DELPHIMagField.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4DELPHIMagField.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DELPHIMagField.cc,v 1.6 2006/06/29 18:23:39 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 // -------------------------------------------------------------------
 
Index: trunk/source/geometry/magneticfield/src/G4ElectricField.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ElectricField.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ElectricField.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ElectricField.cc,v 1.2 2006/06/29 18:23:42 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4ElectroMagneticField.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ElectroMagneticField.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ElectroMagneticField.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ElectroMagneticField.cc,v 1.3 2006/06/29 18:23:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4EqEMFieldWithSpin.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4EqEMFieldWithSpin.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4EqEMFieldWithSpin.cc	(revision 1231)
@@ -25,15 +25,14 @@
 //
 //
-// $Id: G4EqEMFieldWithSpin.cc,v 1.4 2008/11/21 21:17:03 gum Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4EqEMFieldWithSpin.cc,v 1.8 2009/11/06 22:31:35 gum Exp $
+// GEANT4 tag $Name:  $
 //
 //
 //  This is the standard right-hand side for equation of motion.
 //
-//  The only case another is required is when using a moving reference
-//  frame ... or extending the class to include additional Forces,
-//  eg an electric field
-//
 //  30.08.2007 Chris Gong, Peter Gumplinger
+//  14.02.2009 Kevin Lynch
+//  06.11.2009 Hiromi Iinuma see:
+//  http://hypernews.slac.stanford.edu/HyperNews/geant4/get/emfields/161.html
 //
 // -------------------------------------------------------------------
@@ -45,6 +44,6 @@
 
 G4EqEMFieldWithSpin::G4EqEMFieldWithSpin(G4ElectroMagneticField *emField )
-      : G4EquationOfMotion( emField )
-{ 
+  : G4EquationOfMotion( emField )
+{
   anomaly = 0.0011659208;
 }
@@ -79,6 +78,19 @@
 
    // Components of y:
-   //    0-2 dr/ds, 
-   //    3-5 dp/ds - momentum derivatives 
+   //    0-2 dr/ds,
+   //    3-5 dp/ds - momentum derivatives
+   //    9-11 dSpin/ds = (1/beta) dSpin/dt - spin derivatives
+
+   // The BMT equation, following J.D.Jackson, Classical
+   // Electrodynamics, Second Edition,
+   // dS/dt = (e/mc) S \cross
+   //              [ (g/2-1 +1/\gamma) B
+   //               -(g/2-1)\gamma/(\gamma+1) (\beta \cdot B)\beta
+   //               -(g/2-\gamma/(\gamma+1) \beta \cross E ]
+   // where
+   // S = \vec{s}, where S^2 = 1
+   // B = \vec{B}
+   // \beta = \vec{\beta} = \beta \vec{u} with u^2 = 1
+   // E = \vec{E}
 
    G4double pSquared = y[3]*y[3] + y[4]*y[4] + y[5]*y[5] ;
@@ -89,11 +101,7 @@
    G4double pModuleInverse  = 1.0/std::sqrt(pSquared) ;
 
-   //  G4double inverse_velocity = Energy * c_light * pModuleInverse;
    G4double inverse_velocity = Energy * pModuleInverse / c_light;
 
    G4double cof1     = fElectroMagCof*pModuleInverse ;
-
-   //  G4double vDotE = y[3]*Field[3] + y[4]*Field[4] + y[5]*Field[5] ;
-
 
    dydx[0] = y[3]*pModuleInverse ;                         
@@ -113,4 +121,7 @@
    
    G4ThreeVector BField(Field[0],Field[1],Field[2]);
+   G4ThreeVector EField(Field[3],Field[4],Field[5]);
+
+   EField /= c_light;
 
    G4ThreeVector u(y[3], y[4], y[5]);
@@ -119,12 +130,14 @@
    G4double udb = anomaly*beta*gamma/(1.+gamma) * (BField * u);
    G4double ucb = (anomaly+1./gamma)/beta;
+   G4double uce = anomaly + 1./(gamma+1.);
 
    G4ThreeVector Spin(y[9],y[10],y[11]);
 
-   if (Spin.mag() > 0.) Spin = Spin.unit();
-
-   G4ThreeVector dSpin;
-
-   dSpin = ParticleCharge*omegac*(ucb*(Spin.cross(BField))-udb*(Spin.cross(u)));
+   G4ThreeVector dSpin
+     = ParticleCharge*omegac*( ucb*(Spin.cross(BField))-udb*(Spin.cross(u))
+                               // from Jackson
+                               // -uce*Spin.cross(u.cross(EField)) );
+                               // but this form has one less operation
+                               - uce*(u*(Spin*EField) - EField*(Spin*u)) );
 
    dydx[ 9] = dSpin.x();
Index: trunk/source/geometry/magneticfield/src/G4EqMagElectricField.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4EqMagElectricField.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4EqMagElectricField.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EqMagElectricField.cc,v 1.14 2008/04/24 12:33:35 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4EquationOfMotion.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4EquationOfMotion.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4EquationOfMotion.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EquationOfMotion.cc,v 1.9 2006/06/29 18:23:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // -------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4ErrorMag_UsualEqRhs.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ErrorMag_UsualEqRhs.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ErrorMag_UsualEqRhs.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorMag_UsualEqRhs.cc,v 1.1 2007/05/16 12:54:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4ExactHelixStepper.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ExactHelixStepper.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ExactHelixStepper.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ExactHelixStepper.cc,v 1.9 2008/10/29 14:34:35 gcosmo Exp $ 
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //  Helix a-la-Explicity Euler: x_1 = x_0 + helix(h)
Index: trunk/source/geometry/magneticfield/src/G4ExplicitEuler.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ExplicitEuler.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ExplicitEuler.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ExplicitEuler.cc,v 1.8 2006/06/29 18:23:53 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4FieldManager.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4FieldManager.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4FieldManager.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldManager.cc,v 1.15 2007/12/07 15:34:10 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // -------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4FieldManagerStore.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4FieldManagerStore.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4FieldManagerStore.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldManagerStore.cc,v 1.4 2008/01/17 10:56:23 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // G4FieldManagerStore
Index: trunk/source/geometry/magneticfield/src/G4FieldTrack.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4FieldTrack.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4FieldTrack.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldTrack.cc,v 1.14 2007/10/03 15:34:42 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // -------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4HarmonicPolMagField.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4HarmonicPolMagField.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4HarmonicPolMagField.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HarmonicPolMagField.cc,v 1.6 2006/06/29 18:24:00 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // -------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4HelixExplicitEuler.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4HelixExplicitEuler.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4HelixExplicitEuler.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixExplicitEuler.cc,v 1.8 2007/12/10 16:29:49 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4HelixHeum.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4HelixHeum.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4HelixHeum.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixHeum.cc,v 1.6 2006/06/29 18:24:04 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4HelixImplicitEuler.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4HelixImplicitEuler.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4HelixImplicitEuler.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixImplicitEuler.cc,v 1.6 2006/06/29 18:24:06 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4HelixSimpleRunge.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4HelixSimpleRunge.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4HelixSimpleRunge.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixSimpleRunge.cc,v 1.7 2006/06/29 18:24:08 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4ImplicitEuler.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ImplicitEuler.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ImplicitEuler.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ImplicitEuler.cc,v 1.9 2006/06/29 18:24:11 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/src/G4LineCurrentMagField.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4LineCurrentMagField.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4LineCurrentMagField.cc	(revision 1231)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LineCurrentMagField.cc,v 1.6 2006/06/29 18:24:13 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 // -------------------------------------------------------------------
 
Index: trunk/source/geometry/magneticfield/src/G4LineSection.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4LineSection.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4LineSection.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LineSection.cc,v 1.10 2006/06/29 18:24:16 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4MagErrorStepper.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4MagErrorStepper.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4MagErrorStepper.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagErrorStepper.cc,v 1.13 2006/06/29 18:24:18 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/src/G4MagHelicalStepper.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4MagHelicalStepper.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4MagHelicalStepper.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagHelicalStepper.cc,v 1.23 2007/09/05 12:20:17 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
